//------------------------------------------------------
// module  : MDS.cc
// author  : Ayman Khlif and Mignotte Max
// date    : 
// version : 1.0
// language: C++
// note    :
//------------------------------------------------------
//  

//------------------------------------------------
// INCLDED FILES ---------------------------------
//------------------------------------------------
#include "MDS.h"

//------------------------------------------------
// CONSTANTS -------------------------------------
//------------------------------------------------

//------------------------------------------------
// GLOBAL VARIABLES ------------------------------
//------------------------------------------------

//-------------------------
//--- Functions -----------
//-------------------------
//------------------------------------------------
// fmatrix_allocate_2d
//------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
{
 float **matrix;
 float *imptr;
 int i;

   matrix=(float**)malloc((vsize)*sizeof(float*));
   imptr=(float*)malloc((hsize)*(vsize)*sizeof(float));
   if (imptr==NULL) exit(-1);
  
   for(i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
   return matrix;
}

//----------------------------------------------------------
//----------------------------------------------------------
// MAIN PROGRAM --------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
int main()
{ 

//-------------------------------
//--MDS 
//-------------------------------

  int k,l,m;
  float tmp;
  float** MyDistxMatx;
  float** RedData;

  float MyPts[4][6];
  MyPts[0][0]=10;
  MyPts[0][1]=5;
  MyPts[0][2]=10;
  MyPts[0][3]=8;
  MyPts[0][4]=9;
  MyPts[0][5]=6;
 
  MyPts[1][0]=11;
  MyPts[1][1]=7;
  MyPts[1][2]=10;
  MyPts[1][3]=10;
  MyPts[1][4]=8;
  MyPts[1][5]=6;

  MyPts[2][0]=11;
  MyPts[2][1]=7;
  MyPts[2][2]=9;
  MyPts[2][3]=11;
  MyPts[2][4]=8;
  MyPts[2][5]=7;

  MyPts[3][0]=11;
  MyPts[3][1]=7;
  MyPts[3][2]=10;
  MyPts[3][3]=9;
  MyPts[3][4]=8;
  MyPts[3][5]=6;

  MyDistxMatx=fmatrix_allocate_2d(4,4);
  RedData=fmatrix_allocate_2d(4,2);

  for(k=0;k<4;k++) for(l=0;l<4;l++) MyDistxMatx[k][l]=0.0;
  for(k=0;k<3;k++) for(l=k+1;l<4;l++)
    { for(tmp=0.0,m=0;m<6;m++) tmp+=(MyPts[k][m]-MyPts[l][m])*(MyPts[k][m]-MyPts[l][m]);
      MyDistxMatx[k][l]=MyDistxMatx[l][k]=sqrt(tmp); }

//-------------------------------
  MDS* mds=new MDS();
  (*mds).ReduceMDS(MyDistxMatx,4,2,RedData);

  for(k=0;k<4;k++) 
    { printf("\n");
      for(l=0;l<2;l++) printf("[%.5f]",RedData[k][l]);
    }
//-------------------------------


   //Return
   printf("\n C'est fini... \n"); 
   return 0;
 }
 


