//------------------------------------------------------
// module  : FunctionSCVOIC2.cc
// auteur  : 
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionSCVOIC.h"

//----------------------------------------------------------
// LoadTabSeg
//
//>Dans TabSeg[][321][481] 
//----------------------------------------------------------
void LoadTabSegAndImg(int**** TabImg,int*** TabSeg,int NbSegs,int lgth,int wdth,int opt)
{
 int i,j,k,l,p,m;
 int ImgLgth,ImgWdth;
 int NumberImg; 
 int MedianNbImg;
 char Extens[200],BufName[200];
 int NbTotRegions;
 
 //>Init
 NbTotRegions=0;

 //>Include _&_Cst
 #include "DataBase_300.h"
 #include "DataBaseImg_300.h"
 const int NB_MAX_HUM_SEGS=10;

 //>MemoryAllocation >ListSeg[lgth=321][wdth=481]
 int*** ListSeg=imatrix_allocate_3d(NB_MAX_HUM_SEGS,lgth,wdth);
 int**  SegH=imatrix_allocate_2d(lgth,wdth);
 int**  SegV=imatrix_allocate_2d(wdth,lgth);
 int*   HistReg=imatrix_allocate_1d(256);
 float**  ListNbReg=fmatrix_allocate_2d(10,2);
 int*** ImgH=imatrix_allocate_3d(3,lgth,wdth);
 int*** ImgV=imatrix_allocate_3d(3,wdth,lgth);

 //>Presentation
 printf("\n  Loading Human Segmentations&Img>TabSeg[][321][481] TabImg[][][321][481]...");
 
 //>Loop
 //=================================
 for(p=0;p<(NbSegs);p++)
 {
   //>Info
   printf("\n  %d>",p); 
   fflush(stdout);

     //>ForEachHumanSeg
     for(l=0;l<NB_MAX_HUM_SEGS;l++) 
        { ListNbReg[l][0]=0.0;
          ListNbReg[l][1]=l; }
     NumberImg=-1;
     for(k=1;k<NB_MAX_HUM_SEGS;k++)
        { //>Name
          strcpy(BufName,BufNameImg[p]);
          sprintf(Extens,"_%d.pgm",k);
          strcat(BufName,Extens);

          //>GetDim_&_Fill
          if (!GetLengthWidth(BufName,&ImgLgth,&ImgWdth)) break;
          NumberImg++;
          if (ImgLgth==321) 
	     { load_image_pgm(BufName,SegH,ImgLgth,ImgWdth);
               CopyMat(ListSeg[NumberImg],SegH,ImgLgth,ImgWdth); }

          if (ImgLgth==481) 
	     { load_image_pgm(BufName,SegV,ImgLgth,ImgWdth);
               for(j=0;j<ImgWdth;j++) for(i=0;i<ImgLgth;i++) 
	       ListSeg[NumberImg][j][i]=SegV[i][j]; }

	  printf("[%d]",NumberImg); }

     //>ForEachBerkeleyImg
     strcpy(BufName,BufNameImg_[p]);
     sprintf(Extens,".ppm");
     strcat(BufName,Extens);

     if (ImgLgth==321) 
        { load_image_ppm(BufName,ImgH,ImgLgth,ImgWdth);
          CopyMat(TabImg[p],ImgH,ImgLgth,ImgWdth); }

     if (ImgLgth==481) 
	     { load_image_ppm(BufName,ImgV,ImgLgth,ImgWdth);
               for(k=0;k<3;k++) for(j=0;j<ImgWdth;j++) for(i=0;i<ImgLgth;i++) 
	       TabImg[p][k][j][i]=ImgV[k][i][j]; }

     //>Fill_ListNbReg
     for(k=0;k<(NumberImg+1);k++)
        { for(l=0;l<256;l++) HistReg[l]=0;
          for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) HistReg[ListSeg[k][i][j]]++;
          for(l=0;l<256;l++) if (HistReg[l]) ListNbReg[k][0]++; }

     //>ChooseMedian_NbRegion
     //sort(ListNbReg,0,NumberImg+1,2);
     //MedianNbImg=(int)(NumberImg/2);
     //NbTotRegions+=(int)ListNbReg[MedianNbImg][0];
     //MedianNbImg=(int)ListNbReg[MedianNbImg][1];
     //CopyMat(TabSeg[p],ListSeg[MedianNbImg],lgth,wdth); 

     //>ChooseMin_NbRegion
     sort(ListNbReg,0,NumberImg+1,2);
     MedianNbImg=0;
     NbTotRegions+=(int)ListNbReg[MedianNbImg][0];
     CopyMat(TabSeg[p],ListSeg[MedianNbImg],lgth,wdth); 

     //>Info&Verif
     if (!opt)
        { for(l=0;l<(NumberImg+1);l++) printf("\n  [NbRegions=%.0f::SegNb=%.0f]",ListNbReg[l][0],ListNbReg[l][1]); 
          printf("\n  MedianImgNumber=[%d]",MedianNbImg);
          for(l=0;l<256;l++) HistReg[l]=0;
          for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) HistReg[TabSeg[p][i][j]]++;
          for(l=0,m=0;l<256;l++) if (HistReg[l]) m++;
          printf("(with %d regions)",m); }
 } 

 //>Info
 printf("\n  >> NbMoyRegions=[%.1f]",(float)NbTotRegions/(float)NbSegs);
 fflush(stdout);

 //>FreeMemory
 if (ListSeg) free_imatrix_3d(ListSeg,NB_MAX_HUM_SEGS);
 if (SegH) free_imatrix_2d(SegH);
 if (SegV) free_imatrix_2d(SegV);
 if (HistReg)    free_imatrix_1d(HistReg);
 if (ListNbReg)  free_fmatrix_2d(ListNbReg);
 if (ImgH)       free_imatrix_3d(ImgH,3);
 if (ImgV)       free_imatrix_3d(ImgV,3);
}

//----------------------------------------------------------
// LoadTabSegSq
//
//>Dans TabSeg[][SIZE=321][SIZE=321]
//----------------------------------------------------------
void LoadTabSegSqAndImg(int**** TabImg,int*** TabSeg,int NbSegs,int lgth,int wdth,int opt)
{
 int i,j,k,l,p,m;
 int ImgLgth,ImgWdth;
 int NumberImg; 
 int MedianNbImg;
 char Extens[200],BufName[200];
 float row,col;
 int Sz_Max,Sz_Min;
 int NbTotRegions;
 
 //>Init
 NbTotRegions=0;

 //>Sz:Min/Max
 Sz_Max=MAX(lgth,wdth);
 Sz_Min=MIN(lgth,wdth);

 //>Include _&_Cst
 #include "DataBase_300.h"
 #include "DataBaseImg_300.h"
 const int NB_MAX_HUM_SEGS=10;
 const int SIZE=Sz_Min;

 //>MemoryAllocation >ListSeg[lgth=321][wdth=321]
 int*** ListSeg=imatrix_allocate_3d(NB_MAX_HUM_SEGS,SIZE,SIZE);
 int**  SegH=imatrix_allocate_2d(lgth,wdth);
 int**  SegV=imatrix_allocate_2d(wdth,lgth);
 int*   HistReg=imatrix_allocate_1d(256);
 float**  ListNbReg=fmatrix_allocate_2d(NB_MAX_HUM_SEGS,2);
 int*** ImgH=imatrix_allocate_3d(3,lgth,wdth);
 int*** ImgV=imatrix_allocate_3d(3,wdth,lgth);

 //>Presentation
 printf("\n  Loading Human Segmentations&Img>TabSeg[][%d][%d] TabImg[][][%d][%d]...",Sz_Min,Sz_Min,Sz_Min,Sz_Min);
 
 //>Loop
 //=================================
 for(p=0;p<(NbSegs);p++)
 {
   //>Info
   printf("\n  %d>",p); 
   fflush(stdout);

     //>ForEachHumanSeg
     for(l=0;l<NB_MAX_HUM_SEGS;l++) 
        { ListNbReg[l][0]=0.0;
          ListNbReg[l][1]=l; }
     NumberImg=-1;
     for(k=1;k<NB_MAX_HUM_SEGS;k++)
        { //>Name
          strcpy(BufName,BufNameImg[p]);
          sprintf(Extens,"_%d.pgm",k);
          strcat(BufName,Extens);

          //>GetDim_&_Fill
          if (!GetLengthWidth(BufName,&ImgLgth,&ImgWdth)) break;
          NumberImg++;
          if (ImgLgth==Sz_Min) 
	     { load_image_pgm(BufName,SegH,ImgLgth,ImgWdth);

               for(i=0;i<ImgLgth;i++) for(j=0;j<ImgWdth;j++)
		 {  col=(int)(((float)j/(float)Sz_Max)*(float)SIZE);
                    ListSeg[NumberImg][i][(int)col]=SegH[i][j]; }  }

          if (ImgLgth==Sz_Max) 
	     { load_image_pgm(BufName,SegV,ImgLgth,ImgWdth);

               for(i=0;i<ImgLgth;i++) for(j=0;j<ImgWdth;j++) 
		 {  row=(int)(((float)i/(float)Sz_Max)*(float)SIZE); 
                    ListSeg[NumberImg][(int)row][j]=SegV[i][j]; }
             }

	  printf("[%d]",NumberImg); }

      //>ForEachBerkeleyImg
     strcpy(BufName,BufNameImg_[p]);
     sprintf(Extens,".ppm");
     strcat(BufName,Extens);

     if (ImgLgth==Sz_Min) 
        { load_image_ppm(BufName,ImgH,ImgLgth,ImgWdth);
          
          for(k=0;k<3;k++) for(i=0;i<ImgLgth;i++) for(j=0;j<ImgWdth;j++)
	     {  col=(int)(((float)j/(float)Sz_Max)*(float)SIZE);
		TabImg[p][k][i][(int)col]=ImgH[k][i][j]; } }

     if (ImgLgth==Sz_Max) 
	{ load_image_ppm(BufName,ImgV,ImgLgth,ImgWdth);

          for(k=0;k<3;k++) for(i=0;i<ImgLgth;i++) for(j=0;j<ImgWdth;j++) 
             {  row=(int)(((float)i/(float)Sz_Max)*(float)SIZE); 
	        TabImg[p][k][(int)row][j]=ImgV[k][i][j]; } }

               
     //>Fill_ListNbReg
     for(k=0;k<(NumberImg+1);k++)
        { for(l=0;l<256;l++) HistReg[l]=0;
          for(i=0;i<SIZE;i++) for(j=0;j<SIZE;j++) HistReg[ListSeg[k][i][j]]++;
          for(l=0;l<256;l++) if (HistReg[l]) ListNbReg[k][0]++; }

     //>ChooseMedian_NbRegion
     sort(ListNbReg,0,NumberImg+1,2);
     MedianNbImg=(int)(NumberImg/2);
     NbTotRegions+=(int)ListNbReg[MedianNbImg][0];
     MedianNbImg=(int)ListNbReg[MedianNbImg][1];
     CopyMat(TabSeg[p],ListSeg[MedianNbImg],lgth,wdth); 

     //>ChooseMin_NbRegion
     //sort(ListNbReg,0,NumberImg+1,2);
     //MedianNbImg=0;
     //NbTotRegions+=(int)ListNbReg[MedianNbImg][0];
     //CopyMat(TabSeg[p],ListSeg[MedianNbImg],lgth,wdth); 

     //>Info&Verif
     if (!opt)
        { for(l=0;l<(NumberImg+1);l++) printf("\n  [NbRegions=%.0f::SegNb=%.0f]",ListNbReg[l][0],ListNbReg[l][1]); 
          printf("\n  MedianImgNumber=[%d]",MedianNbImg);
          for(l=0;l<256;l++) HistReg[l]=0;
          for(i=0;i<SIZE;i++) for(j=0;j<SIZE;j++) HistReg[TabSeg[p][i][j]]++;
          for(l=0,m=0;l<256;l++) if (HistReg[l]) m++;
          printf("(with %d regions)",m); } 
 } 

 //>Info
 printf("\n  >> NbMoyRegions=[%.1f]",(float)NbTotRegions/(float)NbSegs);
 fflush(stdout);

 //>FreeMemory
 if (ListSeg) free_imatrix_3d(ListSeg,NB_MAX_HUM_SEGS);
 if (SegH) free_imatrix_2d(SegH);
 if (SegV) free_imatrix_2d(SegV);
 if (HistReg)    free_imatrix_1d(HistReg);
 if (ListNbReg)  free_fmatrix_2d(ListNbReg);
 if (ImgH)       free_imatrix_3d(ImgH,3);
 if (ImgV)       free_imatrix_3d(ImgV,3);
}

//-------------------------
//-------------------------
//----------------------------------------------------------
// Normalize
//----------------------------------------------------------
void Normalize(int*** VctSeg,int NbSegs,int LgthImg,int WdthImg)
{
 int i,j,k,l,m;

 //>Presentation
 printf("\n\n  >>NormalizeSegs[%d][%d]",LgthImg,WdthImg);

 //>MemoryAllocation
 int** VctClass=imatrix_allocate_2d(2,256);

 //>Loop
 for(k=0;k<NbSegs;k++) 
    { for(m=0;m<2;m++) for(l=0;l<256;l++) VctClass[m][l]=0;
      for(i=0;i<LgthImg;i++) for(j=0;j<WdthImg;j++)  VctClass[0][VctSeg[k][i][j]]++;
      for(m=0,l=0;l<256;l++) if (VctClass[0][l]) { VctClass[1][l]=m; m++; }
      for(i=0;i<LgthImg;i++) for(j=0;j<WdthImg;j++) VctSeg[k][i][j]=VctClass[1][VctSeg[k][i][j]];  }
 
 //>FreeMemory
 if (VctClass) free_imatrix_2d(VctClass);
}

//----------------------------------------------------------
// VisuMatrix
//----------------------------------------------------------
void VisuMatrix(float** Matrix,int Lgth,int Wdth)
{
 int i,j;

 for(i=0;i<Lgth;i++) 
    { printf("\n");
      for(j=0;j<Wdth;j++) printf("[%.2f]",Matrix[i][j]); }
 fflush(stdout);
}

//-------------------------
//-------------------------
//----------------------------------------------------------
// VisuTabSegAll (with VctSegCtr)
//----------------------------------------------------------
void VisuTabSegAll(int*** VctSeg,int NbSegs,int LgthImg,int WdthImg,int* VctClass,int NbClass,int*** VctSegCtr,int fact,char* Name)
{
 int i,j,k,p;
 int row,col;
 int lgth,wdth;
 int idx_row,idx_col;
 int valmax;

 //>Presentation
 printf("\n  >> VisuTabSegAll [size>%d:%d][Fact:%d]",LgthImg,WdthImg,fact);
 fflush(stdout);

 //>MemoryAllocation
 int* VctNbImg=imatrix_allocate_1d(NbClass);
 int** Lut=imatrix_allocate_2d(256,3);
 
 //>Length/Width Big_Picture
 for(k=0;k<NbClass;k++) VctNbImg[k]=0;
 for(k=0;k<NbSegs;k++)  VctNbImg[VctClass[k]]++;
 for(valmax=0,k=0;k<NbClass;k++) if (VctNbImg[k]>valmax) valmax=VctNbImg[k];
 valmax+=2;
 lgth=(valmax*LgthImg/fact);
 wdth=(NbClass*WdthImg/fact);
 printf("\n MaxNbSamplesPerClass+2=[%d]",valmax);
 printf("\n Lgth/Wdth_Img=[l=%d::w=%d]",lgth,wdth); 
 fflush(stdout);
 int**  BigImg=imatrix_allocate_2d(lgth,wdth);
 int*** BigImgCoul=imatrix_allocate_3d(TROIS,lgth,wdth);

 //>Init
 for(k=0;k<TROIS;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { BigImg[i][j]=0;
     BigImgCoul[k][i][j]=0; }
 
 //>Fill_Big_Picture_N&B_Data
 idx_row=0;
 idx_col=0;
 for(p=0;p<NbClass;p++)
    { idx_row=0;
      for(k=0;k<NbSegs;k++) if (VctClass[k]==p)
       { for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
	 if (((idx_row+row)<lgth)&&(idx_col+col<wdth)) BigImg[idx_row+row][idx_col+col]=VctSeg[k][i][j];	   
	 idx_row+=(LgthImg/fact); }
      idx_col+=(WdthImg/fact); }

 //>Fill_Big_Picture_N&B_Ctr
 idx_col=0;
 idx_row=lgth-(LgthImg/fact);
 for(k=0;k<NbClass;k++) 
    { for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
      if (((idx_row+row)<lgth)&&(idx_col+col<wdth)) BigImg[idx_row+row][idx_col+col]=VctSegCtr[k][i][j];	   
      idx_col+=(WdthImg/fact); }

 //>Fill_Big_Picture_Coul
 for(k=0;k<256;k++) 
   { if (!k) { Lut[0][0]=255;
               Lut[0][1]=255;
               Lut[0][2]=255; 
               continue; }
     Lut[k][0]=(int)(randomize()*255.0);
     Lut[k][1]=(int)(randomize()*255.0);
     Lut[k][2]=(int)(randomize()*255.0); }

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    { BigImgCoul[0][i][j]=Lut[BigImg[i][j]][0];
      BigImgCoul[1][i][j]=Lut[BigImg[i][j]][1];
      BigImgCoul[2][i][j]=Lut[BigImg[i][j]][2]; }

 //>Save
 SaveImagePpm(Name,"",BigImgCoul,lgth,wdth); 

 //>FreeMemory
 if (VctNbImg)   free_imatrix_1d(VctNbImg);
 if (BigImg)     free_imatrix_2d(BigImg);
 if (BigImgCoul) free_imatrix_3d(BigImgCoul,TROIS);
 if (Lut)        free_imatrix_2d(Lut); 
}

//----------------------------------------------------------
// VisuTabSegAll_Img (with VctSegCtr)
//----------------------------------------------------------
void VisuTabSegAll_Img(int**** VctImgCol,int NbSegs,int LgthImg,int WdthImg,\
int* VctClass,int NbClass,int*** VctSegCtr,int fact,char* Name)
{
  int i,j,k,l,p;
 int row,col;
 int lgth,wdth;
 int idx_row,idx_col;
 int valmax;

 //>Presentation
 printf("\n  >> VisuTabSegAll_Img");
 fflush(stdout);

 //>MemoryAllocation
 int* VctNbImg=imatrix_allocate_1d(NbClass);
 int** Lut=imatrix_allocate_2d(256,3);
 
 //>Length/Width Big_Picture
 for(k=0;k<NbClass;k++) VctNbImg[k]=0;
 for(k=0;k<NbSegs;k++)  VctNbImg[VctClass[k]]++;
 for(valmax=0,k=0;k<NbClass;k++) if (VctNbImg[k]>valmax) valmax=VctNbImg[k];
 valmax+=2;
 lgth=(valmax*LgthImg/fact);
 wdth=(NbClass*WdthImg/fact);
 printf("\n MaxNbSamplesPerClass+2=[%d]",valmax);
 printf("\n Lgth/Wdth_Img=[l=%d::w=%d]",lgth,wdth); 
 fflush(stdout);
 int*** BigImgCoul=imatrix_allocate_3d(TROIS,lgth,wdth);

 //>Init
 for(k=0;k<TROIS;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) BigImgCoul[k][i][j]=0; 
 
 //>Fill_Big_Picture
 idx_row=0;
 idx_col=0;
 for(p=0;p<NbClass;p++)
    { idx_row=0;
      for(k=0;k<NbSegs;k++) if (VctClass[k]==p)
       { for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
	 if (((idx_row+row)<lgth)&&(idx_col+col<wdth)) for(l=0;l<TROIS;l++) 
         BigImgCoul[l][idx_row+row][idx_col+col]=VctImgCol[k][l][i][j];
	   
	 idx_row+=(LgthImg/fact); }
         idx_col+=(WdthImg/fact); }

 //>Fill_Big_Picture_Ctr
 idx_col=0;
 idx_row=lgth-(LgthImg/fact);
 for(k=0;k<NbClass;k++) 
    { for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
      if (((idx_row+row)<lgth)&&(idx_col+col<wdth)) BigImgCoul[0][idx_row+row][idx_col+col]=VctSegCtr[k][i][j];	   
      idx_col+=(WdthImg/fact); }

 //>Fill_Big_Picture_Coul
 for(k=0;k<256;k++) 
   { if (!k) { Lut[0][0]=255;
               Lut[0][1]=255;
               Lut[0][2]=255; 
               continue; }
     Lut[k][0]=(int)(randomize()*255.0);
     Lut[k][1]=(int)(randomize()*255.0);
     Lut[k][2]=(int)(randomize()*255.0); }

 for(i=lgth-(LgthImg/fact);i<lgth;i++) for(j=0;j<wdth;j++)  
    { BigImgCoul[0][i][j]=Lut[BigImgCoul[0][i][j]][0];
      BigImgCoul[1][i][j]=Lut[BigImgCoul[0][i][j]][1];
      BigImgCoul[2][i][j]=Lut[BigImgCoul[0][i][j]][2]; }

 //>Save
 SaveImagePpm(Name,"Img",BigImgCoul,lgth,wdth); 

 //>FreeMemory
 if (VctNbImg)   free_imatrix_1d(VctNbImg);
 if (BigImgCoul) free_imatrix_3d(BigImgCoul,TROIS);
 if (Lut)        free_imatrix_2d(Lut); 
}

//----------------------------------------------------------
// VisuTabSegAll_Seg (with VctSegCtr)
//----------------------------------------------------------
void VisuTabSegAll_Seg(int**** VctImgCol,int*** VctSeg,int NbSegs,int LgthImg,int WdthImg, \
int* VctClass,int NbClass,int*** VctSegCtr,int fact,char* Name)
{
 int i,j,k,l,p;
 int row,col;
 int lgth,wdth;
 int idx_row,idx_col;
 int valmax;
 int Nbclass;
 float cr,cv,cb,nb;

 //>Constant
 const float CLARITY=0.75;

 //>Presentation
 printf("\n  >> VisuTabSegAll_Seg");
 fflush(stdout);

 //>MemoryAllocation
 int* VctNbImg=imatrix_allocate_1d(NbClass);
 int** Lut=imatrix_allocate_2d(256,3);
 
 //>Length/Width Big_Picture
 for(k=0;k<NbClass;k++) VctNbImg[k]=0;
 for(k=0;k<NbSegs;k++)  VctNbImg[VctClass[k]]++;
 for(valmax=0,k=0;k<NbClass;k++) if (VctNbImg[k]>valmax) valmax=VctNbImg[k];
 valmax+=2;
 lgth=(valmax*LgthImg/fact);
 wdth=(NbClass*WdthImg/fact);
 printf("\n MaxNbSamplesPerClass+2=[%d]",valmax);
 printf("\n Lgth/Wdth_Img=[l=%d::w=%d]",lgth,wdth); 
 fflush(stdout);
 int*** BigImgCoul=imatrix_allocate_3d(TROIS,lgth,wdth);

 //>Init
 for(k=0;k<TROIS;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) BigImgCoul[k][i][j]=0; 
 
 //>Fill_Big_Picture
 idx_row=0;
 idx_col=0;
 for(p=0;p<NbClass;p++)
    { idx_row=0;
      for(k=0;k<NbSegs;k++) if (VctClass[k]==p)
       { Nbclass=0;
         for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
	 if (((idx_row+row)<lgth)&&(idx_col+col<wdth))  
	    { BigImgCoul[0][idx_row+row][idx_col+col]=VctSeg[k][i][j];
	      if (VctSeg[k][i][j]>Nbclass) Nbclass=VctSeg[k][i][j]; }

             //>Copy_Mean_Color 
             for(l=0;l<=Nbclass;l++)
	     {
             cr=cv=cb=nb=0.0;
             for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
	     if (((idx_row+row)<lgth)&&(idx_col+col<wdth))
             if (VctSeg[k][i][j]==l)
                { cr+=VctImgCol[k][0][i][j];
                  cv+=VctImgCol[k][1][i][j];
                  cb+=VctImgCol[k][2][i][j];
                  nb++; }

             if (nb) { cr/=(nb*CLARITY); cv/=(nb*CLARITY); cb/=(nb*CLARITY); }
             cr=MIN(cr,255);
             cv=MIN(cv,255);
             cb=MIN(cb,255);

             for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
	     if (((idx_row+row)<lgth)&&(idx_col+col<wdth))
             if (VctSeg[k][i][j]==l) 
	         { BigImgCoul[0][idx_row+row][idx_col+col]=(int)cr;
                   BigImgCoul[1][idx_row+row][idx_col+col]=(int)cv; 
                   BigImgCoul[2][idx_row+row][idx_col+col]=(int)cb;  }
             }

 
	 idx_row+=(LgthImg/fact); }
         idx_col+=(WdthImg/fact); }


 //>Fill_Big_Picture_Ctr
 idx_col=0;
 idx_row=lgth-(LgthImg/fact);
 for(k=0;k<NbClass;k++) 
    { for(row=0,i=0;i<LgthImg;i+=fact,row++) for(col=0,j=0;j<WdthImg;j+=fact,col++) 
      if (((idx_row+row)<lgth)&&(idx_col+col<wdth)) BigImgCoul[0][idx_row+row][idx_col+col]=VctSegCtr[k][i][j];	   
      idx_col+=(WdthImg/fact); }

 //>Fill_Big_Picture_Coul
 for(k=0;k<256;k++) 
   { if (!k) { Lut[0][0]=255;
               Lut[0][1]=255;
               Lut[0][2]=255; 
               continue; }
     Lut[k][0]=(int)(randomize()*255.0);
     Lut[k][1]=(int)(randomize()*255.0);
     Lut[k][2]=(int)(randomize()*255.0); }

 for(i=lgth-(LgthImg/fact);i<lgth;i++) for(j=0;j<wdth;j++)  
    { BigImgCoul[0][i][j]=Lut[BigImgCoul[0][i][j]][0];
      BigImgCoul[1][i][j]=Lut[BigImgCoul[0][i][j]][1];
      BigImgCoul[2][i][j]=Lut[BigImgCoul[0][i][j]][2]; }

 //>Save
 SaveImagePpm(Name,"",BigImgCoul,lgth,wdth); 

 //>FreeMemory
 if (VctNbImg)   free_imatrix_1d(VctNbImg);
 if (BigImgCoul) free_imatrix_3d(BigImgCoul,TROIS);
 if (Lut)        free_imatrix_2d(Lut); 
}

//----------------------------------------------------------
// Visu2DMapppingMDS_Img
//----------------------------------------------------------
void Visu2DMapppingMDS_Img(int**** VctImgCol,int NbSegs,int LgthImg,int WdthImg\
,float** ReducedData,int FctRed,float MxCoordMds)
{
 int i,j,k,l; 
 int Row,Col;
 char Buf[NCHAR],Buftmp[NCHAR];

 //>Constant
 const int FACT_RED=FctRed;
 const float MAX_COORD_MDS=MxCoordMds;
 const int SIZE_MDS_IMG=2000;
 const int COL_BACKGROUND=192;
 const float SCALE_MDS_COORD=SIZE_MDS_IMG/MAX_COORD_MDS;

 //>Presentation
 printf("\n  >> Visu2DMapppingMDS_WithImg");
 fflush(stdout);

 //>MemoryAllocation
 int*** ImgMDS=imatrix_allocate_3d(TROIS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>Init
 for(i=0;i<SIZE_MDS_IMG;i++) for(j=0;j<SIZE_MDS_IMG;j++) 
 ImgMDS[0][i][j]=ImgMDS[1][i][j]=ImgMDS[2][i][j]=COL_BACKGROUND; 

 //>LOOP
 for(l=0;l<NbSegs;l++)
    { //>Thumbnail:[Row,Col]
      Col=(int)(ReducedData[l][0]*SCALE_MDS_COORD);
      Row=(int)(ReducedData[l][1]*SCALE_MDS_COORD);
 
      //>Print_Thumbnail
      for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
      if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))   
      for(k=0;k<TROIS;k++)      
      ImgMDS[k][Row+i][Col+j]=VctImgCol[l][k][i*FACT_RED][j*FACT_RED]; }

 
 //>SaveImg
 strcpy(Buf,"MappingImg_MDS");
 sprintf(Buftmp,"_Nb%d",NbSegs);
 strcat(Buf,Buftmp);
 SaveImagePpm(Buf,"",ImgMDS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>FreeMemory
 if (ImgMDS) free_imatrix_3d(ImgMDS,TROIS);
}

//----------------------------------------------------------
// Visu2DMapppingMDS_Img
//----------------------------------------------------------
void Visu2DMapppingMDS_Seg(int**** VctImgCol,int*** VctSeg,int NbSegs,int LgthImg,int WdthImg \
,float** ReducedData,int FctRed,float MxCoordMds)
{
 int i,j,k,l; 
 int Row,Col;
 int Nbclass;
 float cr,cv,cb,nb;
 char Buf[NCHAR],Buftmp[NCHAR];

 //>Constant
 const int FACT_RED=FctRed;
 const float MAX_COORD_MDS=MxCoordMds;
 const float CLARITY=0.75;
 const int SIZE_MDS_IMG=2000;
 const int COL_BACKGROUND=192;
 const float SCALE_MDS_COORD=SIZE_MDS_IMG/MAX_COORD_MDS;

 //>Presentation
 printf("\n  >> Visu2DMapppingMDS_WithSeg");
 fflush(stdout);

 //>MemoryAllocation
 int*** ImgMDS=imatrix_allocate_3d(TROIS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>Init
 for(i=0;i<SIZE_MDS_IMG;i++) for(j=0;j<SIZE_MDS_IMG;j++) 
 ImgMDS[0][i][j]=ImgMDS[1][i][j]=ImgMDS[2][i][j]=COL_BACKGROUND; 

 //>LOOP
 for(l=0;l<NbSegs;l++)
    { //>Thumbnail:[Row,Col]
      Col=(int)(ReducedData[l][0]*SCALE_MDS_COORD);
      Row=(int)(ReducedData[l][1]*SCALE_MDS_COORD);
 
      //>Print_Thumbnail_Seg
      Nbclass=0;
      for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
      if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))      
	 { ImgMDS[0][Row+i][Col+j]=VctSeg[l][i*FACT_RED][j*FACT_RED]; 
           if (VctSeg[l][i*FACT_RED][j*FACT_RED]>Nbclass) Nbclass=VctSeg[l][i*FACT_RED][j*FACT_RED]; }

      //>Copy_Mean_Color 
      for(k=0;k<=Nbclass;k++)
	 {
          cr=cv=cb=nb=0.0;
          for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
          if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))  
	    if (VctSeg[l][i*FACT_RED][j*FACT_RED]==k) 
	     { cr+=VctImgCol[l][0][i*FACT_RED][j*FACT_RED];
               cv+=VctImgCol[l][1][i*FACT_RED][j*FACT_RED];
               cb+=VctImgCol[l][2][i*FACT_RED][j*FACT_RED];
               nb++; }
       
          if (nb) { cr/=(nb*CLARITY); cv/=(nb*CLARITY); cb/=(nb*CLARITY); }
          cr=MIN(cr,255);
          cv=MIN(cv,255);
          cb=MIN(cb,255);
        
          for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
          if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))  
	  if (VctSeg[l][i*FACT_RED][j*FACT_RED]==k) 
	     { ImgMDS[0][Row+i][Col+j]=(int)cr;
               ImgMDS[1][Row+i][Col+j]=(int)cv; 
               ImgMDS[2][Row+i][Col+j]=(int)cb;  }
         }   
    }

 //>SaveImg
 strcpy(Buf,"MappingSeg_MDS");
 sprintf(Buftmp,"_Nb%d",NbSegs);
 strcat(Buf,Buftmp);
 SaveImagePpm(Buf,"",ImgMDS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>FreeMemory
 if (ImgMDS) free_imatrix_3d(ImgMDS,TROIS);
}

//----------------------------------------------------------
// Visu2DMapppingMDS_Img_E
//----------------------------------------------------------
void Visu2DMapppingMDS_Img_E(int**** VctImgCol,int NbSegs,int LgthImg,int WdthImg\
,float** ReducedData,int FctRed,float rowdeb,float coldeb,float SizeImg)
{
 int i,j,k,l; 
 int Row,Col;
 char Buf[NCHAR],Buftmp[NCHAR];

 //>Constant
 const int FACT_RED=FctRed;
 const float MAX_COORD_MDS=SizeImg;
 const int SIZE_MDS_IMG=2000;
 const int COL_BACKGROUND=192;
 const float SCALE_MDS_COORD=SIZE_MDS_IMG/MAX_COORD_MDS;

 //>Presentation
 printf("\n  >> Visu2DMapppingMDS_WithImg_E");
 fflush(stdout);

 //>MemoryAllocation
 int*** ImgMDS=imatrix_allocate_3d(TROIS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>Init
 for(i=0;i<SIZE_MDS_IMG;i++) for(j=0;j<SIZE_MDS_IMG;j++) 
 ImgMDS[0][i][j]=ImgMDS[1][i][j]=ImgMDS[2][i][j]=COL_BACKGROUND; 

 //>LOOP
 for(l=0;l<NbSegs;l++)
    { //>Thumbnail:[Row,Col]
      Col=(int)((ReducedData[l][0]-coldeb)*SCALE_MDS_COORD);
      Row=(int)((ReducedData[l][1]-rowdeb)*SCALE_MDS_COORD);
 
      //>Print_Thumbnail
      for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
      if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))   
      for(k=0;k<TROIS;k++)      
      ImgMDS[k][Row+i][Col+j]=VctImgCol[l][k][i*FACT_RED][j*FACT_RED]; }

 //>SaveImg
 strcpy(Buf,"MappingImg_MDS_E");
 sprintf(Buftmp,"_P%.1f_%.1f_%.1f",rowdeb,coldeb,SizeImg);
 strcat(Buf,Buftmp);
 sprintf(Buftmp,"_Nb%d",NbSegs);
 strcat(Buf,Buftmp);
 SaveImagePpm(Buf,"",ImgMDS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>FreeMemory
 if (ImgMDS) free_imatrix_3d(ImgMDS,TROIS);
}

//----------------------------------------------------------
// Visu2DMapppingMDS_Img
//----------------------------------------------------------
void Visu2DMapppingMDS_Seg_E(int**** VctImgCol,int*** VctSeg,int NbSegs,int LgthImg,int WdthImg \
,float** ReducedData,int FctRed,float rowdeb,float coldeb,float SizeImg)
{
 int i,j,k,l; 
 int Row,Col;
 int Nbclass;
 float cr,cv,cb,nb;
 char Buf[NCHAR],Buftmp[NCHAR];

 //>Constant
 const int FACT_RED=FctRed;
 const float MAX_COORD_MDS=SizeImg;
 const float CLARITY=0.75;
 const int SIZE_MDS_IMG=2000;
 const int COL_BACKGROUND=192;
 const float SCALE_MDS_COORD=SIZE_MDS_IMG/MAX_COORD_MDS;

 //>Presentation
 printf("\n  >> Visu2DMapppingMDS_WithSeg");
 fflush(stdout);

 //>MemoryAllocation
 int*** ImgMDS=imatrix_allocate_3d(TROIS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>Init
 for(i=0;i<SIZE_MDS_IMG;i++) for(j=0;j<SIZE_MDS_IMG;j++) 
 ImgMDS[0][i][j]=ImgMDS[1][i][j]=ImgMDS[2][i][j]=COL_BACKGROUND; 

 //>LOOP
 for(l=0;l<NbSegs;l++)
    { //>Thumbnail:[Row,Col]
      Col=(int)((ReducedData[l][0]-coldeb)*SCALE_MDS_COORD);
      Row=(int)((ReducedData[l][1]-rowdeb)*SCALE_MDS_COORD);
 
      //>Print_Thumbnail_Seg
      Nbclass=0;
      for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
      if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))      
	 { ImgMDS[0][Row+i][Col+j]=VctSeg[l][i*FACT_RED][j*FACT_RED]; 
           if (VctSeg[l][i*FACT_RED][j*FACT_RED]>Nbclass) Nbclass=VctSeg[l][i*FACT_RED][j*FACT_RED]; }

      //>Copy_Mean_Color 
      for(k=0;k<=Nbclass;k++)
	 {
          cr=cv=cb=nb=0.0;
          for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
          if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))  
	    if (VctSeg[l][i*FACT_RED][j*FACT_RED]==k) 
	     { cr+=VctImgCol[l][0][i*FACT_RED][j*FACT_RED];
               cv+=VctImgCol[l][1][i*FACT_RED][j*FACT_RED];
               cb+=VctImgCol[l][2][i*FACT_RED][j*FACT_RED];
               nb++; }
       
          if (nb) { cr/=(nb*CLARITY); cv/=(nb*CLARITY); cb/=(nb*CLARITY); }
          cr=MIN(cr,255);
          cv=MIN(cv,255);
          cb=MIN(cb,255);
        
          for(i=0;i<(LgthImg/FACT_RED);i++) for(j=0;j<(WdthImg/FACT_RED);j++) 
          if (((Row+i)>0)&&((Col+j)>0)&&((Row+i)<SIZE_MDS_IMG)&&((Col+j)<SIZE_MDS_IMG))  
	  if (VctSeg[l][i*FACT_RED][j*FACT_RED]==k) 
	     { ImgMDS[0][Row+i][Col+j]=(int)cr;
               ImgMDS[1][Row+i][Col+j]=(int)cv; 
               ImgMDS[2][Row+i][Col+j]=(int)cb;  }
         }   
    }

 //>SaveImg
 strcpy(Buf,"MappingSeg_MDS");
 sprintf(Buftmp,"_Nb%d",NbSegs);
 strcat(Buf,Buftmp);
 SaveImagePpm(Buf,"",ImgMDS,SIZE_MDS_IMG,SIZE_MDS_IMG);

 //>FreeMemory
 if (ImgMDS) free_imatrix_3d(ImgMDS,TROIS);
}

//----------------------------------------------------------
// Visu2D_Img<<VctImgCol>>
//----------------------------------------------------------
void Visu2D_Img(int**** VctImgCol,int NbImgs,int LgthImg,int WdthImg,char* Com)
{
 int i,j,k,l; 
 int dec;
 char Buf[NCHAR],Buftmp[NCHAR];

 //>Presentation
 printf("\n  >> Visu2D_Img<<VctImgCol>>");
 fflush(stdout);

 //>MemoryAllocation
 int*** ImgMDS=imatrix_allocate_3d(TROIS,LgthImg,WdthImg*NbImgs);

 //>LOOP
 for(dec=0,l=0;l<NbImgs;l++,dec+=LgthImg)
    { for(k=0;k<TROIS;k++) 
      for(i=0;i<LgthImg;i++) for(j=0;j<WdthImg;j++) ImgMDS[k][i][j+dec]=VctImgCol[l][k][i][j]; }

 //>SaveImg
 sprintf(Buf,"%sVisu2DImg",Com);
 sprintf(Buftmp,"Nb%d",NbImgs);
 strcat(Buf,Buftmp);
 SaveImagePpm(Buf,"",ImgMDS,LgthImg,WdthImg*NbImgs);

 //>FreeMemory
 if (ImgMDS) free_imatrix_3d(ImgMDS,TROIS);
}

//----------------------------------------------------------
// Visu2D_Img<<VctSeg>>
//----------------------------------------------------------
void Visu2D_Img(int*** VctSeg,int NbImgs,int LgthImg,int WdthImg,char* Com)
{
 int i,j,l; 
 int dec;
 char Buf[NCHAR],Buftmp[NCHAR];

 //>Presentation
 printf("\n  >> Visu2D_Img<<VctSeg>>");
 fflush(stdout);

 //>MemoryAllocation
 int** ImgMDS=imatrix_allocate_2d(LgthImg,WdthImg*NbImgs);

 //>LOOP
 for(dec=0,l=0;l<NbImgs;l++,dec+=LgthImg)
    { for(i=0;i<LgthImg;i++) for(j=0;j<WdthImg;j++) ImgMDS[i][j+dec]=VctSeg[l][i][j]; }

 //>SaveImg
 sprintf(Buf,"%sVisu2DImg",Com);
 sprintf(Buftmp,"Nb%d",NbImgs);
 strcat(Buf,Buftmp);
 SaveImagePgm(Buf,"",ImgMDS,LgthImg,WdthImg*NbImgs);

 //>FreeMemory
 if (ImgMDS) free_imatrix_2d(ImgMDS);
}

//----------------------------------------------------------
// VisuAgglomerations
//----------------------------------------------------------
void VisuAgglomerations(int** MatxDistFus,int**** VctImgCol,int NbImg,int Lgth,int Wdth,int FACTVIS,char* Name)
{
 int i,j,k,l,p; 
 int nb;
 char Buf[NCHAR],Buftmp[NCHAR];

 //>Constant
 const int NB_IMAGES=NbImg;
 const int LGTH_AGG_IMG=(NB_IMAGES)*(Wdth/FACTVIS);
 const int WDTH_AGG_IMG=LGTH_AGG_IMG;
 const int Lgth_IMG=Lgth/FACTVIS;
 const int Wdth_IMG=Wdth/FACTVIS;
 
 //>Presentation
 printf("\n   >> Visu_Agglomerations");
 fflush(stdout);

 //>MemoryAllocation
 int*** ImgAGG=imatrix_allocate_3d(TROIS,LGTH_AGG_IMG,WDTH_AGG_IMG);

 //>Init
 for(k=0;k<TROIS;k++) for(i=0;i<LGTH_AGG_IMG;i++) for(j=0;j<WDTH_AGG_IMG;j++) ImgAGG[k][i][j]=0;

 //>Loop
 for(p=0;p<(NbImg-1);p++)
    {
     //>Info
      printf("[%d]>",p);
      fflush(stdout);
     
     //>Display
     for(l=0;l<(NbImg-1);l++) 
        { if (MatxDistFus[p][l]==-1) break; 
          else 
	    { nb=MatxDistFus[p][l]; 

              for(k=0;k<TROIS;k++) for(i=0;i<Lgth/FACTVIS;i++) for(j=0;j<Wdth/FACTVIS;j++) 
	      ImgAGG[k][i+(p*Lgth_IMG)][j+(l*Wdth_IMG)]=VctImgCol[nb][k][i*FACTVIS][j*FACTVIS]; } }
    }

 //>SaveImg
 sprintf(Buf,"%s_Agglom",Name);
 sprintf(Buftmp,"_Nb%d",NbImg);
 strcat(Buf,Buftmp);
 SaveImagePpm(Buf,"",ImgAGG,LGTH_AGG_IMG,WDTH_AGG_IMG);
 
 //>FreeMemory
 if (ImgAGG)  free_imatrix_3d(ImgAGG,TROIS);
}

//-------------------------
//-------------------------
//----------------------------------------------------------
// WithinInertieVOI
//----------------------------------------------------------
float WithinInertieVOI(int*** TabSeg,int NbSegs,int lgth,int wdth,int NbClusters,int* VctLabel,int*** MatxCtrSegs)
{
 int k,l;
 float DistInertieVoi;

 //>Loop
 DistInertieVoi=0.0;
 for(k=0;k<NbClusters;k++)
    { for(l=0;l<NbSegs;l++) if (VctLabel[l]==k)
      DistInertieVoi+=VariationInformation(MatxCtrSegs[k],TabSeg[l],lgth,wdth);  } 

 //>Return
 return DistInertieVoi/(float)NbClusters;
}

//----------------------------------------------------------
// BetweenInertieVOI
//----------------------------------------------------------
float BetweenInertieVOI(int lgth,int wdth,int NbClusters,int*** MatxCtrSegs)
{
 int k,l;
 float DistInertieVoi;
 //float nb;

 //>Loop
 DistInertieVoi=0.0;
 for(k=0;k<NbClusters;k++) for(l=0;l<NbClusters;l++) if (l!=k)
 DistInertieVoi+=VariationInformation(MatxCtrSegs[k],MatxCtrSegs[l],lgth,wdth); 

 //nb=(NbClusters)*(NbClusters-1); 

 //>Return
 return DistInertieVoi/(float)NbClusters;
}

//------------------------------------------------------------------------------
// DownSamplingVctSeg
//  TabSegIn[lgth][wdth]>>TabSegOut[(int)(lgth/szbl)][(int)(wdth/szbl)]
//------------------------------------------------------------------------------
void DownSamplingVctSeg(int*** TabSegIn,int NbSegs,int lgth,int wdth,int szbl,int*** TabSegOut)
{
 int i,j,k,m,n;
 int nb;
 int valmax,labmax;
 int RedLgth,RedWdth;

 //>Presentation
 printf("\n  >> DownSampling ...");

  //>MemoryAllocation
 int* VctLabel=imatrix_allocate_1d(szbl*szbl);
 int* HistoLab=imatrix_allocate_1d(256);

 //>Init
 RedLgth=(int)(lgth/szbl);
 RedWdth=(int)(wdth/szbl);
 for(k=0;k<NbSegs;k++) for(i=0;i<RedLgth;i++) for(j=0;j<RedWdth;j++) TabSegOut[k][i][j]=0;

 //>Loop
 for(k=0;k<NbSegs;k++)
    {
     for(i=0;i<RedLgth;i++) for(j=0;j<RedWdth;j++)
        {
	 for(m=0;m<(szbl*szbl);m++) VctLabel[m]=-1;
         for(m=0;m<256;m++) HistoLab[m]=0;

	 nb=0;
         for(m=(i*szbl);m<(i*szbl+szbl);m++) for(n=(j*szbl);n<(j*szbl+szbl);n++) 
	   if ((m<lgth)&&(n<wdth)) VctLabel[nb++]=TabSegIn[k][m][n];

         for(m=0;m<(szbl*szbl);m++) if (VctLabel[m]>=0) HistoLab[VctLabel[m]]++;
         
         valmax=0;
         labmax=0;
         for(m=0;m<256;m++) if (HistoLab[m]>valmax) {  valmax=HistoLab[m]; labmax=m; }

         TabSegOut[k][i][j]=labmax;	     
        }

     //Debug
     //Recal(TabSegOut[k],RedLgth,RedWdth); 
     //SaveImagePgm("ImgSave","",TabSegOut[k],RedLgth,RedWdth); 
     //exit(-1);
    }

 //>FreeMemory
 if (VctLabel)  free_imatrix_1d(VctLabel);
 if (HistoLab)  free_imatrix_1d(HistoLab);
}

//----------------------------------------------------------
// UpSampling
//----------------------------------------------------------
void UpSampling(int** MatIn,int** MatOut,int scale,int lgth,int wdth)
{
 int i,j;

 //>Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatOut[i][j]=0;

 //>Decimation Inverse
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 if ((int(i/scale)<(lgth/scale))&&(int(j/scale)<(wdth/scale))) 
    MatOut[i][j]=MatIn[(int)(i/scale)][(int)(j/scale)];
} 

//----------------------------------------------------------
// KmeansVOI initialized with [MatxCtrSegs]
//----------------------------------------------------------
void CompMatxDistVOI(int*** TabSeg,int NbSegs,int lgth,int wdth,float** MatxDistVOI)
{
 int k,l;

 //>Presentation
 printf("\n\n  >> Compute_VoI_Distance_Matrix");
 fflush(stdout);

 //>Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbSegs;l++) MatxDistVOI[k][l]=0.0;
 
 //>Loop
 for(k=0;k<NbSegs;k++) for(l=0;l<k;l++) 
    { MatxDistVOI[k][l]=VariationInformation(TabSeg[k],TabSeg[l],lgth,wdth);  
      MatxDistVOI[l][k]=MatxDistVOI[k][l]; }

 //>Debug
 //for(k=0;k<NbSegs;k++) 
 //  { printf("\n");
 //    for(l=0;l<NbSegs;l++) printf("[%.3f]",MatxDistVOI[k][l]); }
}

//----------------------------------------------------------
// ComputeDiversity
//----------------------------------------------------------
float ComputeDiversity(float** MatxDistVOI,int NbSegs)
{
 int k,l;
 float Diversity;
 
 //>Presentation
 printf("\n\n  >> Compute_Diversity");
 fflush(stdout);

 //>Loop
 Diversity=0.0; 
 for(k=0;k<NbSegs;k++) for(l=0;l<NbSegs;l++) Diversity+=MatxDistVOI[k][l];
 Diversity/=(float)CARRE(NbSegs);

 //>Retour
 return Diversity;
}

//----------------------------------------------------------
// RangeAlwaysPositive
//----------------------------------------------------------
void RangeAlwaysPositive(float** RedDt,int NbSegs,int NbPar)
{
 int i,j;
 float min;

 //>Loop
 for(j=0;j<NbPar;j++) 
   { min=1000000; 
     for(i=0;i<NbSegs;i++) if (RedDt[i][j]<min)  min=RedDt[i][j]; 
     for(i=0;i<NbSegs;i++) RedDt[i][j]+=-min; }
}

//----------------------------------------------------------
// ComputeStat
//----------------------------------------------------------
void ComputeStat(float** Matx,int NbSegs,int NbPar,float** TabRange)
{
 int i,j;
 float min,max;

 //>Loop
 for(j=0;j<NbPar;j++) 
   { min=1000000; 
     max=-100000;
     for(i=0;i<NbSegs;i++) 
       { if (Matx[i][j]<min)  min=Matx[i][j];
         if (Matx[i][j]>max)  max=Matx[i][j]; }
     TabRange[j][0]=min;
     TabRange[j][1]=max; }
}

//----------------------------------------------------------
// ComputeSqrtMatrix
//----------------------------------------------------------
void ComputeSqrtMatrix(float** Matx,int lgth,int wdth)
{
 int i,j;

 //>ComputeSqrt 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Matx[i][j]=sqrt(Matx[i][j]);
}

//=============================================================================
//=============================================================================
// K-MEANS-VOI
//=============================================================================
//=============================================================================
//----------------------------------------------------------
// KmeansVOI
//
// [opt=0]> Voibfm_ :: << Init: Lines_Hor_Vert >>
// [opt=1]> Init Voibfm :: << Init: Lines_Hor_Vert LowRes > HighRes >>
// [opt=2]> VoibfmM ::  << Init: Best of NSEGS >>
//
//----------------------------------------------------------
void KmeansVOI(int*** TabSeg,int NbSegs,int lgth,int wdth,int NbClusters,int* VctLabel,int*** MatxCtrSegs,int opt)
{
 int i,j,l,m,n;
 int classe;
 float aleat;
 int nb;
 float dist,distmin;
 int flag;

 //>Cst
 const int MAX_NB_ITERS=50;
 const int MIN_NB_ITERS=5;

 //>MemoryAllocation
 int*** MatrixCtrSegs=imatrix_allocate_3d(NbClusters,lgth,wdth);
 int*** VctSegs=imatrix_allocate_3d(NbSegs,lgth,wdth);
 float** Seg=fmatrix_allocate_2d(lgth,wdth);

 //>Presentation
 printf("\n\n  K-Means-VOI [NbSegs=%d][NbClusters=%d][opt=%d][size=%d:%d]",NbSegs,NbClusters,opt,lgth,wdth);
 printf("\n  --------------------------------------------------------");
 if (opt==0) printf("\n    >Init: Lines_Hor_Vert");
 if (opt==1) printf("\n    >Init: Lines_Hor_Vert [LowRes>HighRes]");
 if (opt==2) printf("\n    >Init: Best of NSEGS");

 //>Initialize_Centroid_Segmentation
 //---------------------------------------------------------------  
  if (0)                 
  for(i=0;i<NbClusters;i++) 
     { aleat=(i+1)*(NbSegs/(NbClusters+2));
       CopyMat(MatrixCtrSegs[i],TabSeg[(int)aleat],lgth,wdth); } 

  if (1)
  for(i=0;i<NbClusters;i++) 
    {  aleat=(int)(i);
       printf(" (%d)",(int)aleat);
       CopyMat(MatrixCtrSegs[i],TabSeg[(int)aleat],lgth,wdth); }
 //------------------------------------------------------------------

 //>Initialize
  for(n=0;n<NbSegs;n++) VctLabel[n]=-1;
 
 printf("\n    ");
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<MAX_NB_ITERS;l++)
   {
    //-[1]>Select_Cluster_Membership
    //-------------------------------
    flag=0; classe=0;
    for(j=0;j<NbSegs;j++)
          { distmin=BIGNUMBER;
            for(i=0;i<NbClusters;i++)
               {               
                //VOI- distance
                dist=VariationInformation(MatrixCtrSegs[i],TabSeg[j],lgth,wdth);     
                if (dist<distmin) { distmin=dist; classe=i; }
	       }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

     //-[2]>Stop_Criterion_&_Info
     //---------------------------
     printf("\n\n   >>>>>>>>>>>>>>[Iter::%d >> Chgt::%d] \n",l,flag); fflush(stdout); 
     if ((!flag)&&(l>MIN_NB_ITERS))  {  printf("   FIN-K-Mean\n"); break;  }

     //-[3]>Update_Centroid_For_Each_Cluster
     //-------------------------------------
      printf("   [Update]");
      for(i=0;i<NbClusters;i++) 
	 { printf("\n  [Clust:%d]",i);                   
	   for(nb=0,j=0;j<NbSegs;j++) if (VctLabel[j]==i) CopyMat(VctSegs[nb++],TabSeg[j],lgth,wdth);
           printf("[NbSegs:%d][size:%d:%d][opt=%d]",nb,lgth,wdth,opt); 
	   if (nb)
	      { if (opt==0) Voibfm_(VctSegs,nb,Seg,lgth,wdth);
                if (opt==1) Voibfm(VctSegs,nb,Seg,lgth,wdth);
                if (opt==2) VoibfmM(VctSegs,nb,Seg,lgth,wdth); 
                for(m=0;m<lgth;m++) for(n=0;n<wdth;n++)  MatrixCtrSegs[i][m][n]=(int)Seg[m][n]; }
           else for(m=0;m<lgth;m++) for(n=0;n<wdth;n++)  MatrixCtrSegs[i][m][n]=0;
         }

   }//==============================================================
 //================================================================= 

 //>Update_&_Transfert
 //----------------------------------------------------------------------------- 
  //if (!opt) ComputeCtr(TabSeg,NbSegs,lgth,wdth,NbClusters,VctLabel,MatrixCtrSegs);   //-???????  
  for(i=0;i<NbClusters;i++) CopyMat(MatxCtrSegs[i],MatrixCtrSegs[i],lgth,wdth); 
 //-----------------------------------------------------------------------------

 //>FreeMemory
 if (MatrixCtrSegs) free_imatrix_3d(MatrixCtrSegs,NbClusters);
 if (VctSegs)       free_imatrix_3d(VctSegs,NbSegs);
 if (Seg)           free_fmatrix_2d(Seg);
}

//----------------------------------------------------------
// KmeansVOI initialized with [MatxCtrSegs]
//
// [opt=1]> Voibfm_ :: << Init: Lines_Hor_Vert >>
// [opt=0]> VoibfmM :: << Init: Best of NSEGS >>
//
//----------------------------------------------------------
void KmeansVOI_InitMatx(int*** TabSeg,int NbSegs,int lgth,int wdth,int NbClusters,int* VctLabel,int*** MatxCtrSegs,int opt)
{
 int i,j,k,l,m,n;
 int classe;
 int nb;
 float dist,distmin;
 int flag;

 //>Cst
 const int MAX_NB_ITERS=50;
 const int MIN_NB_ITERS=5;

 //>MemoryAllocation
 int*** MatrixCtrSegs=imatrix_allocate_3d(NbClusters,lgth,wdth);
 int*** VctSegs=imatrix_allocate_3d(NbSegs,lgth,wdth);
 float** Seg=fmatrix_allocate_2d(lgth,wdth);

 //>Presentation
 printf("\n\n\n  K-means-VOI <Init.WithMatxCtrSegs> [NbSegs=%d][NbClusters=%d]",NbSegs,NbClusters);
 printf("\n  -----------------------------------------------------------------");
 if (opt==0) printf("\n    >Init: Best of NSEGS");
 if (opt==1) printf("\n    >Init: Lines_Hor_Vert");

 //>Initialize Centroid Segmentation
 //---------------------------------------------------------------------------
 for(k=0;k<NbClusters;k++) CopyMat(MatrixCtrSegs[k],MatxCtrSegs[k],lgth,wdth); 
 //---------------------------------------------------------------------------
 
 printf("\n    ");
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<MAX_NB_ITERS;l++)
   {
    //-[1]>Select_Cluster_Membership
    //-------------------------------
    flag=0; classe=0;
    for(j=0;j<NbSegs;j++)
          { distmin=BIGNUMBER;
            for(i=0;i<NbClusters;i++)
               {               
                //VOI- distance
                dist=VariationInformation(MatrixCtrSegs[i],TabSeg[j],lgth,wdth);     
                if (dist<distmin) { distmin=dist; classe=i; }
	       }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

     //-[2]>Stop_Criterion_&_Info
     //---------------------------
     printf("\n\n   >>>>>>>>>>>>>>[Iter::%d >> Chgt::%d] \n",l,flag); fflush(stdout); 
     if ((!flag)&&(l>MIN_NB_ITERS))  break;

     //-[3]>Update_Centroid_For_Each_Cluster
     //-------------------------------------
      printf("[Update]");
      for(i=0;i<NbClusters;i++) 
	 { printf("[Clust:%d]",i);                   
	   for(nb=0,j=0;j<NbSegs;j++) if (VctLabel[j]==i) CopyMat(VctSegs[nb++],TabSeg[j],lgth,wdth);
           printf("[NbSegs:%d]",nb);  
           if (nb)
	      { if (opt==1) Voibfm_(VctSegs,nb,Seg,lgth,wdth); 
                if (opt==0) VoibfmM(VctSegs,nb,Seg,lgth,wdth); 
                for(m=0;m<lgth;m++) for(n=0;n<wdth;n++)  MatrixCtrSegs[i][m][n]=(int)Seg[m][n]; }
           else for(m=0;m<lgth;m++) for(n=0;n<wdth;n++) MatrixCtrSegs[i][m][n]=0;
         }   

   }//==============================================================
 //================================================================= 
 
 //>Update_&_Transfert
 //----------------------------------------------------------------------------- 
  //if (!opt) ComputeCtr(TabSeg,NbSegs,lgth,wdth,NbClusters,VctLabel,MatrixCtrSegs);   //-???????             
  for(k=0;k<NbClusters;k++) CopyMat(MatxCtrSegs[k],MatrixCtrSegs[k],lgth,wdth); 
 //-----------------------------------------------------------------------------

 //>FreeMemory
 if (MatrixCtrSegs) free_imatrix_3d(MatrixCtrSegs,NbClusters);
 if (VctSegs)       free_imatrix_3d(VctSegs,NbSegs);
 if (Seg)           free_fmatrix_2d(Seg);
}

//----------------------------------------------------------
// ComputeCtr
//
// <opt=0> << Init: Lines_Hor_Vert LowRes > HighRes >>
// <opt=1> << Init: Best of NSEGS LowRes > HighRes >>
// <opt=2> << Init: Best of NSEGS >>
// <opt=3> << Init: MatxCtrSegs[] >>
//
//----------------------------------------------------------
void ComputeCtr(int*** TabSeg,int NbSegs,int lgth,int wdth,int NbClusters,int* VctLabel,int*** MatxCtrSegs,int opt)
{
 int i,j,m,n;
 int nb;

 //>Presentation
 printf("\n\n  Compute_Centers [size=%d:%d][opt=%d]",lgth,wdth,opt);
 printf("\n  UpdateCentralSegmentations [NbSegs=%d][NbClusters=%d]",NbSegs,NbClusters);
 if (opt==0) printf("\n  << Init: Lines_Hor_Vert LowRes > HighRes >>");
 if (opt==1) printf("\n  << Init: Best of NSEGS LowRes > HighRes >>");
 if (opt==2) printf("\n  << Init: Best of NSEGS >>");
 if (opt==3) printf("\n  << Init: MatxCtrSegs[] >>");

 //>MemoryAllocation
 float** Seg=fmatrix_allocate_2d(lgth,wdth);
 int*** VctSegs=imatrix_allocate_3d(NbSegs,lgth,wdth);

 //>Update_Centroid_For_Each_Cluster
 printf("\n [Update] ...");
 for(i=0;i<NbClusters;i++) 
    { printf("[Clust:%d]",i);                   
      for(nb=0,j=0;j<NbSegs;j++) if (VctLabel[j]==i) CopyMat(VctSegs[nb++],TabSeg[j],lgth,wdth);
      printf("[NbSegs:%d]",nb);  
      if (opt==0) Voibfm(VctSegs,nb,Seg,lgth,wdth);
      if (opt==1) VoibfmM2(VctSegs,nb,Seg,lgth,wdth);
      if (opt==2) VoibfmM(VctSegs,nb,Seg,lgth,wdth);
      if (opt==3) { CopyMat(Seg,MatxCtrSegs[i],lgth,wdth); VoibfmI(VctSegs,nb,Seg,lgth,wdth); }
      for(m=0;m<lgth;m++) for(n=0;n<wdth;n++)  MatxCtrSegs[i][m][n]=(int)Seg[m][n]; }

 //>FreeMemory
 if (Seg) free_fmatrix_2d(Seg);
 if (VctSegs) free_imatrix_3d(VctSegs,NbSegs);
}

//=============================================================================
//=============================================================================
// HIERARCHICAL CLUTERING
//=============================================================================
//=============================================================================
//----------------------------------------------------------
// HierarchicalClustering <TabSegSegRed>
//----------------------------------------------------------
void HierarCluster(int*** TabSeg,int NbSegs,int Lgth,int Wdth,int*** TabMatxCent,int** MatxDistFus,int FACTREDSEG,int opt)
{
 int i,j,k,l,m,n,p;
 int row_best,col_best;
 int idx_min,idx_max;
 int lab;
 int nb;
 float MinVoi;
 
 //>Presentation
 printf("\n\n  HierarchicalClustering[NbSegs:%d][Fact=%d]",NbSegs,FACTREDSEG);
 printf("\n  --------------------------------------------\n");
 if (opt==0) printf("\n  << Init: Lines_Hor_Vert L>H >>");
 if (opt==1) printf("\n  << Init: Best of NSEGS L>H >>");
 if (opt==2) printf("\n  << Init: Best of NSEGS >>");
 fflush(stdout);

 //>MemoryAllocation
 float** MatxDistVOI=fmatrix_allocate_2d(NbSegs,NbSegs);
 float** SegCenter=fmatrix_allocate_2d(Lgth,Wdth);
 int***  VctSegs=imatrix_allocate_3d(NbSegs,Lgth,Wdth);
 int***  TabSegUpdate=imatrix_allocate_3d(NbSegs,Lgth,Wdth);
 int*    VctUpdate=imatrix_allocate_1d(NbSegs);
 int***  TabSegRed=imatrix_allocate_3d(NbSegs,Lgth/FACTREDSEG,Wdth/FACTREDSEG);

 //>Init
 for(l=0;l<NbSegs;l++) for(k=0;k<NbSegs;k++) MatxDistFus[l][k]=-1;
 for(k=0;k<NbSegs;k++) for(i=0;i<Lgth;i++) for(j=0;j<Wdth;j++) TabSegUpdate[k][i][j]=TabSeg[k][i][j];

 //>SubSampling
 DownSamplingVctSeg(TabSeg,NbSegs,Lgth,Wdth,FACTREDSEG,TabSegRed);

 //>Compute_DistMatx[VoI]
 printf("\n  >> CompMatxDistVOI_[fact=%d]...",FACTREDSEG); 
 fflush(stdout);
 CompMatxDistVOI(TabSegRed,NbSegs,Lgth/FACTREDSEG,Wdth/FACTREDSEG,MatxDistVOI);

 //>DEBUG
 //VisuMatrix(MatxDistVOI,NbSegs,NbSegs);

 //>Loop
 for(p=0;p<(NbSegs-1);p++)
    {
     //>Info
      printf("\n\n  <[%d]>",p);
      fflush(stdout);
     
     //>Scrutinize the DistMatx[VoI]>Min[row_best:col_best]
     MinVoi=10000;
     row_best=col_best=-1; 
     for(l=0;l<NbSegs;l++) for(m=0;m<NbSegs;m++) 
     if (l!=m)  if (MatxDistVOI[l][m])
     if (MatxDistVOI[l][m]<MinVoi) { MinVoi=MatxDistVOI[l][m]; row_best=l; col_best=m; }

     //>Info_Fusion
     idx_min=MIN(row_best,col_best);
     idx_max=MAX(row_best,col_best);
     if ((idx_min<0)||(idx_max<0)) { printf("\n Pb Index"); exit(-1); }
     MatxDistFus[p][0]=idx_min;
     MatxDistFus[p][1]=idx_max;

     //>Update[0]:VctUpdate
     for(l=0;l<NbSegs;l++) VctUpdate[l]=-1;
     VctUpdate[0]=idx_min;
     VctUpdate[1]=idx_max; 

     nb=1;
     for(l=p-1;l>=0;l--) if (MatxDistFus[p][0]==MatxDistFus[l][0])
       { for(m=1;m<NbSegs;m++) 
            { if (MatxDistFus[l][m]==-1) break; 
              else VctUpdate[++nb]=MatxDistFus[l][m]; }
	 break; }

     for(l=p-1;l>=0;l--) if (MatxDistFus[p][1]==MatxDistFus[l][0])
       { for(m=1;m<NbSegs;m++) 
            { if (MatxDistFus[l][m]==-1) break; 
              else VctUpdate[++nb]=MatxDistFus[l][m];  }
	 break; } 

     for(l=0;l<NbSegs;l++) { if (VctUpdate[l]==-1) break; 
                             else MatxDistFus[p][l]=VctUpdate[l]; }

     printf("\n   >> Update[%d]_VctUpdate=",p);
     for(l=0;l<NbSegs;l++) { if (VctUpdate[l]==-1) break; 
                             else printf("<%d>",VctUpdate[l]); }
     fflush(stdout);

     //>Update[1]:NewCenter_[-2-Segmentations]
     if (0)
        { CopyMat(VctSegs[0],TabSegUpdate[idx_min],Lgth,Wdth);
          CopyMat(VctSegs[1],TabSegUpdate[idx_max],Lgth,Wdth);
          printf("\n  >> [Segs:%d:%d:VoI=%.2f]",idx_min,idx_max,MinVoi);
          if (opt==0) Voibfm(VctSegs,2,SegCenter,Lgth,Wdth);
          if (opt==1) VoibfmM2(VctSegs,2,SegCenter,Lgth,Wdth);
          if (opt==2) VoibfmM(VctSegs,2,SegCenter,Lgth,Wdth); }

     //>Update[1]:NewCenter_[-All-Segmentations]
     if (1)
        { for(nb=0,l=0;l<NbSegs;l++) 
             { if (VctUpdate[l]==-1) break; 
               CopyMat(VctSegs[nb],TabSegUpdate[VctUpdate[l]],Lgth,Wdth); 
               nb++; }
         if (opt==0) Voibfm(VctSegs,nb,SegCenter,Lgth,Wdth); 
         if (opt==1) VoibfmM2(VctSegs,2,SegCenter,Lgth,Wdth);
         if (opt==2) VoibfmM(VctSegs,2,SegCenter,Lgth,Wdth); }

     //>Update[2]:TabMatxCent
     for(m=0;m<Lgth;m++) for(n=0;n<Wdth;n++) 
     TabMatxCent[p][m][n]=(int)SegCenter[m][n];

     //>Update[3]:TabSegUpdate_&_MatDist
     printf("\n   >> Update_TabSegUpdate_&_MatDist");
     for(l=0;l<NbSegs;l++)
        { if (VctUpdate[l]==-1) break;
          lab=VctUpdate[l];
	  for(m=0;m<Lgth;m++) for(n=0;n<Wdth;n++) TabSegUpdate[lab][m][n]=(int)SegCenter[m][n]; 
          for(k=0;k<NbSegs;k++) { MatxDistVOI[lab][k]=-1;  MatxDistVOI[k][lab]=-1; } }
     
     //>Update[3]:MatDist
     printf("\n   >> Update_MatDist");
     for(k=0;k<NbSegs;k++) for(l=0;l<NbSegs;l++) if (MatxDistVOI[k][l]==-1)
       { MatxDistVOI[k][l]=VariationInformation(TabSegUpdate[k],TabSegUpdate[l],Lgth,Wdth);  
         if (MatxDistVOI[k][l]<0.01) MatxDistVOI[k][l]=0.0; }

     //>DEBUG
     //if (p==30) break;  //--A-ENLEVER-!!!!
    }

 //>FreeMemory
 if (MatxDistVOI)  free_fmatrix_2d(MatxDistVOI);
 if (SegCenter)    free_fmatrix_2d(SegCenter);
 if (VctSegs)      free_imatrix_3d(VctSegs,NbSegs);
 if (TabSegUpdate) free_imatrix_3d(TabSegUpdate,NbSegs);
 if (VctUpdate)    free_imatrix_1d(VctUpdate);
 if (TabSegRed)    free_imatrix_3d(TabSegRed,NbSegs);
}

//----------------------------------------------------------
// VisuHierCl
//----------------------------------------------------------
void VisuHierCl(int**** VctImg,int*** VctSeg,int NbSegs,\
int Lgth,int Wdth,int*** TabMatxCent,int** MatxDistFus,int param)
{
 int i,j,k,l,m,n; 
 int idx_row;
 int idx_first,idx_second;
 int ect_col,ect_row;
 int row,col;
 int Nbclass;
 float cr,cv,cb,nb; 
 char Buf[NCHAR],BufTmp[NCHAR];

 //>Constant
 const int LGTH_HC_IMG=10000;
 const int WDTH_HC_IMG=3000;
 const int NB_IMAGES=300;

 const int  ROW_ECART=LGTH_HC_IMG/NB_IMAGES;
 const int  SCALERED=10;
 const int  ECART_VERT=(int)(0.9*(float)WDTH_HC_IMG/(float)NB_IMAGES);
 const float CLARITY=0.75;
 
 const int COL_BACKGROUND=255;
 const int COL_STROKE=0;
 
 //>Presentation
 printf("\n   >> Visu_HierarchicalClustering [opt=%d]",param);
 fflush(stdout);

 //>MemoryAllocation
 int*** ImgHC=imatrix_allocate_3d(TROIS,LGTH_HC_IMG,WDTH_HC_IMG);
 int**** VctSegCol=imatrix_allocate_4d(NbSegs,TROIS,Lgth,Wdth);
 int** Lut=imatrix_allocate_2d(256,3);

 //>Init
 for(i=0;i<LGTH_HC_IMG;i++) for(j=0;j<WDTH_HC_IMG;j++) 
 ImgHC[0][i][j]=ImgHC[1][i][j]=ImgHC[2][i][j]=COL_BACKGROUND; 

 for(l=0;l<NbSegs;l++)
    { Nbclass=0;
      for(i=0;i<Lgth;i++) for(j=0;j<Wdth;j++)
      if (VctSeg[l][i][j]>Nbclass) Nbclass=VctSeg[l][i][j]; 
 
      for(k=0;k<=Nbclass;k++)
      { cr=cv=cb=nb=0.0;
        for(i=0;i<Lgth;i++) for(j=0;j<Wdth;j++) if (VctSeg[l][i][j]==k) 
           { cr+=VctImg[l][0][i][j];
             cv+=VctImg[l][1][i][j];
             cb+=VctImg[l][2][i][j];
             nb++; }

        if (nb) { cr/=(nb*CLARITY); cv/=(nb*CLARITY); cb/=(nb*CLARITY); }
        cr=MIN(cr,255); cv=MIN(cv,255); cb=MIN(cb,255);

        for(i=0;i<Lgth;i++) for(j=0;j<Wdth;j++) if (VctSeg[l][i][j]==k) 
	   { VctSegCol[l][0][i][j]=(int)cr;
             VctSegCol[l][1][i][j]=(int)cv; 
             VctSegCol[l][2][i][j]=(int)cb;  } }
    }

 for(k=0;k<256;k++) 
   { if (!k) { Lut[0][0]=255;
               Lut[0][1]=255;
               Lut[0][2]=255; 
               continue; }
     Lut[k][0]=(int)(randomize()*255.0/CLARITY);
     Lut[k][1]=(int)(randomize()*255.0/CLARITY);
     Lut[k][2]=(int)(randomize()*255.0/CLARITY); }

 for(idx_row=0,k=0;k<NbSegs;k++,idx_row+=ROW_ECART)
 for(i=0;i<Lgth/SCALERED;i++) for(j=0;j<Wdth/SCALERED;j++) 
 for(l=0;l<3;l++) ImgHC[l][i+idx_row][j]=VctSegCol[k][l][i*SCALERED][j*SCALERED];

 //>LOOP
 ect_row=Lgth/SCALERED;
 ect_col=Wdth/SCALERED;
 for(l=0;l<(NbSegs-1);l++) 
    {
     //>DataToClustered
     idx_first=MatxDistFus[l][0]*ROW_ECART;
     idx_second=MatxDistFus[l][1]*ROW_ECART;

     if ((idx_first<0)||(idx_second<0)) break; //--!

     //>SegmentationCenter
     row=(idx_first+idx_second)/2;
     col=ect_col+((l+1)*ECART_VERT)-(ect_col/2);
     for(i=0;i<Lgth/SCALERED;i++) for(j=0;j<Wdth/SCALERED;j++) for(k=0;k<3;k++) 
     if (((row+i)<LGTH_HC_IMG)&&((col+j)<WDTH_HC_IMG))
     ImgHC[k][row+i][col+j]=Lut[TabMatxCent[l][i*SCALERED][j*SCALERED]][k];

     //>Vertical_Stroke
     for(m=idx_first;m<idx_second;m++) for(k=0;k<TROIS;k++)
     ImgHC[k][m+ROW_ECART/2][ect_col+(l+1)*ECART_VERT]=COL_STROKE;

     //>Horizontal_Stroke
     for(m=(l+1)*ECART_VERT;m>0;m--) for(k=0;k<TROIS;k++)
     ImgHC[k][idx_first+ROW_ECART/2][ect_col+m]=COL_STROKE;

     for(m=(l+1)*ECART_VERT;m>0;m--) for(k=0;k<TROIS;k++)
     ImgHC[k][idx_second+ROW_ECART/2][ect_col+m]=COL_STROKE; 

     //>Point_Fusion
     for(m=-3;m<=3;m++) for(n=-3;n<=3;n++)
       { row=idx_first+ROW_ECART/2+m;
         col=ect_col+(l+1)*ECART_VERT+n;
         if ((row>0)&&(row<LGTH_HC_IMG))
	 if ((col>0)&&(col<WDTH_HC_IMG))
         for(k=0;k<TROIS;k++) ImgHC[k][row][col]=COL_STROKE; }

     for(m=-3;m<=3;m++) for(n=-3;n<=3;n++)
       { row=idx_second+ROW_ECART/2+m;
         col=ect_col+(l+1)*ECART_VERT+n;
         if ((row>0)&&(row<LGTH_HC_IMG))
	 if ((col>0)&&(col<WDTH_HC_IMG))
         for(k=0;k<TROIS;k++) ImgHC[k][row][col]=COL_STROKE; }
    }
 
 //>SaveImg
 strcpy(Buf,"Mapping_HC");
 sprintf(BufTmp,"_Nb%d",NbSegs);
 strcat(Buf,BufTmp);
 sprintf(BufTmp,"_P%d",param);
 strcat(Buf,BufTmp);
 SaveImagePpm(Buf,"",ImgHC,LGTH_HC_IMG,WDTH_HC_IMG);

 //>FreeMemory
 if (ImgHC)     free_imatrix_3d(ImgHC,TROIS);
 if (VctSegCol) free_imatrix_4d(VctSegCol,NbSegs,TROIS);
 if (Lut)       free_imatrix_2d(Lut); 
}


//----------------------------------------------------------
// SeekNbClusters
//----------------------------------------------------------
void SeekNbClusters(int* VctLabel,int NbCluster,int NbSegs,int** MatxDistFus)
{
 int k,l;
 int nbcl;
 int nb;

 //>MemoryAllocation
 int** Vct=imatrix_allocate_2d(2,NbSegs);
 
 //>Presentation
 printf("\n   >> Seek_NbClusters:[%d]\n",NbCluster);
 fflush(stdout);

 //>Init
 for(k=0;k<NbSegs;k++) VctLabel[k]=k;

 //printf("\n");
 //for(k=0;k<NbSegs;k++) printf("{%d}",VctLabel[k]);

 //>LOOP
 for(nbcl=(NbSegs-1),k=0;k<(NbSegs-1);k++,nbcl--)
   {  for(l=1;l<NbSegs;l++) if (MatxDistFus[k][l]!=-1) 
         VctLabel[MatxDistFus[k][l]]=VctLabel[MatxDistFus[k][0]];    
      if (nbcl==NbCluster) break; }

 for(k=0;k<NbSegs;k++) for(l=0;l<2;l++) Vct[l][k]=0;
 for(k=0;k<NbSegs;k++) Vct[0][VctLabel[k]]++;
 for(nb=0,k=0;k<NbSegs;k++) if (Vct[0][k])
    { Vct[1][k]=nb;
      nb++; }
 for(k=0;k<NbSegs;k++) VctLabel[k]=Vct[1][ VctLabel[k]];
 
 //>Info  
 nb=0;
 for(k=0;k<NbCluster;k++) 
   { printf("\n  [%d]>",k);
     for(l=0;l<NbSegs;l++) if (VctLabel[l]==k) 
     { nb++; printf("[%d]",l); } }

 if (nb==NbSegs) printf("\n\n  >>Tout semble correct");
 else printf("\n Problme ?");

 //>FreeMemory
 if (Vct) free_imatrix_2d(Vct); 
}
